org.apache.sysds.hops.rewrite

## Class RewriteTransientWriteParentHandling

- java.lang.Object
- - org.apache.sysds.hops.rewrite.HopRewriteRule
  - - org.apache.sysds.hops.rewrite.RewriteTransientWriteParentHandling

-     public class RewriteTransientWriteParentHandling
      extends HopRewriteRule

  Rule: Eliminate for Transient Write DataHops to have no parents Solution: Move parent edges of Transient Write Hop to parent of its child Reason: Transient Write not being a root messes up analysis for Lop's to Instruction translation (according to Amol)

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `RewriteTransientWriteParentHandling()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Hop` | `rewriteHopDAG(Hop root, ProgramRewriteStatus state)` Handle a predicate hop DAG with exactly one root.
    `ArrayList<Hop>` | `rewriteHopDAGs(ArrayList<Hop> roots, ProgramRewriteStatus state)` Handle a generic (last-level) hop DAG with multiple roots.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### RewriteTransientWriteParentHandling

          public RewriteTransientWriteParentHandling()

  - ### Method Detail

    - #### rewriteHopDAGs

          public ArrayList<Hop> rewriteHopDAGs(ArrayList<Hop> roots,
                                               ProgramRewriteStatus state)

      Description copied from class: `HopRewriteRule`
      Handle a generic (last-level) hop DAG with multiple roots.
      Specified by:
        `rewriteHopDAGs` in class `HopRewriteRule`
      Parameters:
        `roots` - high-level operator roots
        `state` - program rewrite status
      Returns:
        list of high-level operators

    - #### rewriteHopDAG

          public Hop rewriteHopDAG(Hop root,
                                   ProgramRewriteStatus state)

      Description copied from class: `HopRewriteRule`
      Handle a predicate hop DAG with exactly one root.
      Specified by:
        `rewriteHopDAG` in class `HopRewriteRule`
      Parameters:
        `root` - high-level operator root
        `state` - program rewrite status
      Returns:
        high-level operator

Copyright © 2021 The Apache Software Foundation. All rights reserved.